Package net.sf.saxon.value

## Class SequenceExtent

- java.lang.Object
- - net.sf.saxon.value.SequenceExtent

- All Implemented Interfaces:
    `GroundedValue`, `Sequence`
  Direct Known Subclasses:
    `OneOrMore`

      public class SequenceExtent
      extends java.lang.Object
      implements GroundedValue

  A sequence value implemented extensionally. That is, this class represents a sequence by allocating memory to each item in the sequence.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SequenceExtent​(java.util.List<? extends Item> list)` | Construct a SequenceExtent from a List.
    `SequenceExtent​(Item[] items)` | Construct an sequence from an array of items.
    `SequenceExtent​(SequenceIterator iter)` | Construct a sequence containing all the remaining items in a SequenceIterator.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Iterable<? extends Item>` | `asIterable()` | Get the contents of this value in the form of a Java `Iterable`, so that it can be used in a for-each expression
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value
    `static GroundedValue` | `fromIterator​(SequenceIterator iter)` | Deprecated. since 9.9: use `SequenceIterator.materialize()`
    `int` | `getCardinality()` | Determine the cardinality
    `int` | `getLength()` | Get the number of items in the sequence
    `java.lang.String` | `getStringValue()` | Get the string value of this sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of this sequence.
    `Item` | `head()` | Get the first item in the sequence.
    `Item` | `itemAt​(int n)` | Get the n'th item in the sequence (starting with 0 as the first item)
    `ListIterator<? extends Item>` | `iterate()` | Return an iterator over this sequence.
    `java.util.Iterator<? extends Item>` | `iterator()` | Get an iterator (a Java `Iterator`) over the items in this sequence.
    `static GroundedValue` | `makeResidue​(SequenceIterator iter)` | Factory method to make a GroundedValue holding the remaining contents of any SequenceIterator, that is, the contents that have not yet been read
    `static <T extends Item> GroundedValue` | `makeSequenceExtent​(java.util.List<T> input)` | Factory method to make a Value holding the contents of any List of items
    `static GroundedValue` | `makeSequenceExtent​(SequenceIterator iter)` | Deprecated. since 9.9: use `SequenceIterator.materialize()`
    `GroundedValue` | `reduce()` | Reduce the sequence to its simplest form.
    `UnfailingIterator` | `reverseIterate()` | Return an enumeration of this sequence in reverse order (used for reverse axes)
    `GroundedValue` | `subsequence​(int start, int length)` | Get a subsequence of the value
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `concatenate, containsNode, materialize, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### SequenceExtent

          public SequenceExtent​(Item[] items)

      Construct an sequence from an array of items. Note, the array of items is used as is, which means the caller must not subsequently change its contents.
      Parameters:
        `items` - the array of items to be included in the sequence

    - #### SequenceExtent

          public SequenceExtent​(java.util.List<? extends Item> list)

      Construct a SequenceExtent from a List. The members of the list must all be Items
      Parameters:
        `list` - the list of items to be included in the sequence

    - #### SequenceExtent

          public SequenceExtent​(SequenceIterator iter)
                         throws XPathException

      Construct a sequence containing all the remaining items in a SequenceIterator.
      Parameters:
        `iter` - The supplied sequence of items. The returned sequence will contain all items delivered by repeated calls on next() on this iterator, and the iterator will be consumed by calling the method.
      Throws:
        `XPathException` - if reading the items using the SequenceIterator raises an error

  - ### Method Detail

    - #### makeSequenceExtent

          public static GroundedValue makeSequenceExtent​(SequenceIterator iter)
                                                  throws XPathException

      Deprecated.
      since 9.9: use `SequenceIterator.materialize()`
      Factory method to make a GroundedValue holding the contents of any SequenceIterator.
      Parameters:
        `iter` - a Sequence iterator that may or may not be consumed to deliver the items in the sequence. The iterator must be positioned at the start.
      Returns:
        a GroundedValue holding the items delivered by the SequenceIterator. If the sequence is empty the result will be an instance of `EmptySequence`. If it is of length one, the result will be an `Item`. In all other cases, it will be an instance of `SequenceExtent`.
      Throws:
        `XPathException` - if an error occurs processing the values from the iterator.

    - #### fromIterator

          public static GroundedValue fromIterator​(SequenceIterator iter)
                                            throws XPathException

      Deprecated.
      since 9.9: use `SequenceIterator.materialize()`
      Factory method to make a GroundedValue holding the contents of any SequenceIterator.
      Parameters:
        `iter` - a Sequence iterator that may or may not be consumed to deliver the items in the sequence. The iterator must be positioned at the start.
      Returns:
        a GroundedValue holding the items delivered by the SequenceIterator. If the sequence is empty the result will be an instance of `EmptySequence`. If it is of length one, the result will be an `Item`. In other cases, the actual implementation class is not defined.

        This method is intended primarily for internal use. For external applications, calling `SequenceIterator.materialize()` is preferable, because it recognizes cases that can be optimized (notably, cases where the iterator is already backed by an array or list in memory).

      Throws:
        `XPathException` - if an error occurs processing the values from the iterator.

    - #### makeResidue

          public static GroundedValue makeResidue​(SequenceIterator iter)
                                           throws XPathException

      Factory method to make a GroundedValue holding the remaining contents of any SequenceIterator, that is, the contents that have not yet been read
      Parameters:
        `iter` - a Sequence iterator that may or may not be consumed to deliver the items in the sequence. The iterator need not be positioned at the start.
      Returns:
        a GroundedValue holding the items delivered by the SequenceIterator. If the sequence is empty the result will be an instance of `EmptySequence`. If it is of length one, the result will be an `Item`. In all other cases, it will be an instance of `SequenceExtent`.
      Throws:
        `XPathException` - if an error occurs processing the values from the iterator.

    - #### makeSequenceExtent

          public static <T extends Item> GroundedValue makeSequenceExtent​(java.util.List<T> input)

      Factory method to make a Value holding the contents of any List of items
      Parameters:
        `input` - a List containing the items in the sequence. The caller guarantees that this list will not be subsequently modified.
      Returns:
        a ValueRepresentation holding the items in the list. If the sequence is empty the result will be an instance of `EmptySequence`. If it is of length one, the result will be an `Item`. In all other cases, it will be an instance of `SequenceExtent`.

    - #### getStringValue

          public java.lang.String getStringValue()
                                          throws XPathException

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()
                                                  throws XPathException

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.
      Throws:
        `XPathException` - if the sequence contains items that have no string value (for example, function items)

    - #### head

          public Item head()

      Get the first item in the sequence.
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty

    - #### getLength

          public int getLength()

      Get the number of items in the sequence
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### getCardinality

          public int getCardinality()

      Determine the cardinality
      Returns:
        the cardinality of the sequence, using the constants defined in net.sf.saxon.value.Cardinality
      See Also:
        `Cardinality`

    - #### itemAt

          public Item itemAt​(int n)

      Get the n'th item in the sequence (starting with 0 as the first item)
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the position of the required item
      Returns:
        the n'th item in the sequence, or null if the position is out of range

    - #### iterate

          public ListIterator<? extends Item> iterate()

      Return an iterator over this sequence.
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        the required SequenceIterator, positioned at the start of the sequence

    - #### reverseIterate

          public UnfailingIterator reverseIterate()

      Return an enumeration of this sequence in reverse order (used for reverse axes)
      Returns:
        an AxisIterator that processes the items in reverse order

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()
                                        throws XPathException

      Get the effective boolean value
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if the sequence has no effective boolean value (for example a sequence of two integers)

    - #### subsequence

          public GroundedValue subsequence​(int start,
                                           int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `start` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence. If min is

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of One. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence

    - #### asIterable

          public java.lang.Iterable<? extends Item> asIterable()

      Get the contents of this value in the form of a Java `Iterable`, so that it can be used in a for-each expression
      Specified by:
        `asIterable` in interface `GroundedValue`
      Returns:
        an Iterable containing the same sequence of items

    - #### iterator

          public java.util.Iterator<? extends Item> iterator()

      Get an iterator (a Java `Iterator`) over the items in this sequence.
      Returns:
        an iterator over the items in this sequence.